package com.jh.boot.security;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

import com.jh.boot.security.model.AppUser;

public class SecurityHelper {
	
	private SecurityHelper() {
	}

	
	public static AppUser getUser() {
		return (AppUser) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
	}
	
	
	public static AppUser getUser(Authentication auth) {
		if (auth == null) {
			return null;
		}
		
		return (AppUser) auth.getPrincipal();
	}
	
	
	public static boolean hasAnyRole(Authentication auth, String...roles) {
		AppUser user = auth instanceof AppUserAuthentication ? ((AppUserAuthentication) auth).getUser() : null;
		
		if (user == null || user.getRoles() == null || roles == null || roles.length == 0) {
			return false;
		}

		
		for (String role : roles) { 
			if (user.getRolesMap().containsKey(role)) {
				return true;
			}
		}
		
		return false;
	}
	
	
}
